<script setup lang="ts">
import 'swiper/css';
import 'swiper/css/keyboard';
import 'swiper/css/navigation';
import 'swiper/css/pagination';
import { register } from 'swiper/element/bundle';
import { onMounted, onUnmounted, ref } from 'vue';

// Registrar Swiper para Vue 3
onMounted(() => {
  register();
});

// Referencia al contenedor Swiper para capturar eventos y mover slides
const swiperRef = ref<HTMLElement | null>(null);
const timer = ref<number | null>(null); // Almacena el temporizador
const delay = 10000; // Tiempo de retardo en milisegundos (10 segundos)
const isPaused = ref(false); // Estado de pausa del temporizador
const progress = ref(0); // Progreso de la barra de tiempo (0-100)
const interval = 100; // Frecuencia de actualización de la barra en milisegundos
const iframeLoaded = ref(false); // Verifica si el primer iframe se ha cargado


// JSON que contiene las URLs de Grafana
const grafanaPanels = ref([]);


// Función para cargar el JSON desde un archivo externo
const loadDashboards = async () => {
  try {
    const response = await fetch('/dashboards.json');
    if (!response.ok) {
      throw new Error('Error al cargar el archivo JSON');
    }
    const data = await response.json();
    grafanaPanels.value = data;
  } catch (error) {
    console.error('Error al cargar los paneles de Grafana:', error);
  }
};


// Función para pasar a la siguiente diapositiva
const goToNextSlide = () => {
  if (swiperRef.value && !isPaused.value) {
    swiperRef.value.swiper.slideNext();
  }
};

// Función para iniciar o reiniciar el temporizador
const startTimer = () => {
  if (timer.value) clearInterval(timer.value); // Limpiar temporizador existente
  progress.value = 0; // Restablecer progreso de la barra

  const steps = delay / interval; // Número de actualizaciones de la barra
  let currentStep = 0;

  timer.value = setInterval(() => {
    if (isPaused.value) return; // No actualizar si está en pausa
    currentStep += 1;
    progress.value = (currentStep / steps) * 100; // Calcular porcentaje de progreso
    if (currentStep >= steps) {
      goToNextSlide(); // Cambiar a la siguiente diapositiva
      startTimer(); // Reiniciar el temporizador y la barra
    }
  }, interval) as unknown as number;
};

/*
// Función que se ejecuta cuando el primer iframe de Grafana se carga
const onIframeLoaded = () => {
  iframeLoaded.value = true; // Marca que el iframe ha sido cargado
  startTimer(); // Inicia el temporizador
};
*/

const onIframeLoaded = () => {
  if (!iframeLoaded.value) {
    iframeLoaded.value = true; // Marca que el primer iframe ha sido cargado
    console.log('Primer iframe cargado. Iniciando temporizador');
    startTimer(); // Inicia el temporizador solo cuando el primer iframe se haya cargado
  }
};

// Función para pausar o reanudar el temporizador al presionar espacio
const togglePause = () => {
  isPaused.value = !isPaused.value;
  if (isPaused.value) {
    if (timer.value) clearInterval(timer.value); // Si está en pausa, limpiar el temporizador
  } else {
    startTimer(); // Si no está en pausa, reiniciar el temporizador
  }
};

// Función para capturar el evento de teclado
const handleKeydown = (event: KeyboardEvent) => {
  if (event.code === 'Space') { // Si se presiona la tecla de espacio
    event.preventDefault(); // Prevenir el comportamiento por defecto (scrolling)
    togglePause(); // Pausar o reanudar el temporizador
  }
  else if (event.code === 'ArrowRight') { // Si se presiona la tecla de espacio
    startTimer(); 
  }
  else if (event.code === 'ArrowLeft') { // Si se presiona la tecla de espacio
    startTimer(); 
  }
};

// Configuración de eventos y temporizador en la carga del componente
onMounted(async () => {
  window.addEventListener('keydown', handleKeydown);
  await loadDashboards(); // Espera a que los paneles se carguen
  nextTick(() => {
    if (swiperRef.value) {
      swiperRef.value.swiper.update(); // Actualiza Swiper
      console.log('Componentes cargados, iniciando temporizador');
      // startTimer();
    }
  });
});

// Limpiar eventos y temporizador al desmontar el componente
onUnmounted(() => {
  if (timer.value) clearInterval(timer.value);
  window.removeEventListener('keydown', handleKeydown);
});
</script>

<template>
  <div class="swiper-wrapper">
    <!-- Barra de progreso inferior -->
    <div class="progress-bar">
      <div class="progress" :style="{ width: progress + '%' }"></div>
    </div>
    <swiper-container
      ref="swiperRef"
      :navigation="true"
      :pagination="true"
      :loop="true"
      :keyboard="true"
      class="my-swiper-container"
      space-between="30"
      slides-per-view="1"
      :looped-slides="grafanaPanels.length"       
      :loop-additional-slides="0"
      style=" position: relative; block-size: 500px;inline-size: 100%;"
    >
      <!-- Swiper Slide generados dinámicamente desde el JSON -->
      <swiper-slide
        v-for="(panel, index) in grafanaPanels"
        :key="index"
        class="swiper-slide"
      >
        <!-- Iframe de Grafana -->

        <iframe
          :src="panel.url"
          frameborder="0"
          style=" block-size: 100%;inline-size: 100%;"
          @load="onIframeLoaded"
        ></iframe>
      </swiper-slide>
    </swiper-container>
  </div>
</template>

<style scoped>
.my-swiper-container {
  block-size: 500px;
  inline-size: 100%;
}

.swiper-slide {
  display: flex;
  align-items: center;
  justify-content: center;
}

.progress-bar {
  position: absolute;
  z-index: 9;
  background-color: #e6e6e6;
  block-size: 2px;
  inline-size: 100%;
  inset-block-end: -2px;
  inset-inline-start: 0;
}

.progress {
  background-color: #a0a0a0;
  block-size: 100%;
  transition: inline-size 0.1s linear;
}
</style>
